//Dynamic Fractal

//Carlos Gershenson

#include <graphics.h>
#include <stdlib.h>
#include <iostream.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <dos.h>

const n=10;
//number of triangles per lane



void fract(float x1,float y1, float x2,float y2,int m){
  if (random(2))
    setcolor(1);
  else
    setcolor(9);
  //setcolor(m);
  line (x1,y1,x2,y2);
  m--;
  if (m>0){
    int ax1[n+1],ay1[n+1];
    int ax2[n],ay2[n];
    int ax3[n+1],ay3[n+1];
    float l=sqrt(pow(x2-x1,2)+pow(y1-y2,2))/(n);
    float t=atan((y1-y2)/(x2-x1))+(M_PI/3);
    ax1[0]=x1;ay1[0]=y1;
    ax1[n]=x2;ay1[n]=y2;
    for (int i=1;i<n;i++){
      ax1[i]=x1+(i*(x2-x1)/n);
      ay1[i]=y1-(i*(y1-y2)/n);
    }
    for (i=0;i<n;i++){
      ax2[i]=ax1[i]+(l*cos(t));
      ay2[i]=ay1[i]-(l*sin(t));
    }
    t=atan((y1-y2)/(x2-x1))+(M_PI/2);
    for (i=0;i<n+1;i++){
      ax3[i]=ax1[i]+(l*cos(t));
      ay3[i]=ay1[i]-(l*sin(t));
    }
    for (i=0;i<n;i++){
      fract(ax2[i],ay2[i],ax1[i],ay1[i],m);
      fract(ax2[i],ay2[i],ax1[i+1],ay1[i+1],m);
    }
    for (i=0;i<n;i++){
      fract(ax3[i],ay3[i],ax1[i],ay1[i],m);
      fract(ax3[i],ay3[i],ax1[i+1],ay1[i+1],m);
    }
    for (i=0;i<n;i++){
      fract(ax2[i],ay2[i],ax1[i],ay1[i],m);
      fract(ax2[i],ay2[i],ax1[i+1],ay1[i+1],m);
    }
    for (i=0;i<n;i++){
      fract(ax3[i+1],ay3[i+1],ax1[i],ay1[i],m);
      fract(ax3[i+1],ay3[i+1],ax1[i+1],ay1[i+1],m);
    }
  }
/*  delay(10);
  setcolor(0);
  line (x1,y1,x2,y2);
  */
}

int main(void)
{
   int m2;
   textcolor(9);
   cout<<"Dynamic Fractal\n\n"
       <<"by Carlos Gershenson\n\n"
       <<"Number of recursions: ";
   cin>>m2;
   if (m2>6){
     cout<<"Knaive...";
     exit(1);
   }
   randomize();
   int gdriver = DETECT, gmode, errorcode;
   initgraph(&gdriver, &gmode, "");
   errorcode = graphresult();
   if (errorcode != grOk)
   {
	  printf("Error de Grficos: %s\n", grapherrormsg(errorcode));
	  exit(1);
   }

     while(!kbhit())
       fract(100+random(100),400+random(100),500+random(100),400+random(100),m2);

//   getch();
   closegraph();
   return 0;
}
