#include<iostream.h>
#include<stdio.h>
#include<conio.h>

template<class T>
class CNode {
     T valor;
     CNode *nex;
  public:
     CNode(T v){ valor=v;
		nex=NULL;
	      }
     CNode(T v,CNode *s){
	   valor=v;
	   nex=s;
     }
     void link(CNode *s){
	 nex=s;
     }
     void next(CNode *s){
	 link(s);
     }
     CNode *next(void){
	 return nex;
     }
     T val(void){
	return valor;
     }
     int val(T v){
	 return (valor==v)?1:0;
     }
     int operator < (T v){
	 return (valor<v)?1:0;
     }
     int operator > (T v){
	 return (valor>v)?1:0;
     }
};

template<class T>void operator<<(ostream_withassign &cOut,CNode<T> *n){
   cOut<<n->val();
}

template<class T>
class CList {
   protected:
     CNode<T> *head;
   public:
     CList(void){   head=NULL; }
     ~CList(void);
     void operator+(T valor);
     void operator-(T valor);
     void print(void);
};

template<class T> void CList<T>::operator+(T valor){
     if(head==NULL)
	 head=new CNode<T>(valor);
     else{
	 CNode<T> *neww=new CNode<T>(valor);
	 for(CNode<T> *rec=head; rec->next() ; rec=rec->next())
				   ;
	 rec->link(neww);
     }
};

template<class T> void CList<T>::operator-(T valor){
     if(head){
	  if(head->val(valor)){
	     CNode<T> *temp=head;
	     head=head->next();
	     delete temp;
	  }
	  else{
	     CNode<T> *rec=head;
	     while(rec->next() && !rec->next()->val(valor))
		   rec=rec->next();
	     if(rec->next()->val(valor)){
		CNode<T> *temp=rec->next();
		rec->next(rec->next()->next());
		delete temp;
	     }
	  }
     }
}

template<class T> void CList<T>::print(void){
      CNode<T> *rec=head;
      while(rec){
	  cout<<rec;
	  cout<<"\n";
	  rec=rec->next();
      }
}

template<class T>CList<T>::~CList(void){
      CNode<T> *rec=head;
      while(rec){
	  head=rec;
	  rec=rec->next();
	  delete head;
      }
      head=NULL;
}

template<class T>void operator<<(ostream_withassign &,CList<T> &l){
       l.print();
}

void main(void){
   CList<int> l;
   l+1;
   l+2;
   l+4;
   cout<<l;

}