//#include "racional.h"
#include "matrac.h"
#include <conio.h>

CMatrizRacE::CMatrizRacE() // Inicializador
{ CRacional r;
  int i,j;
   for (i=0; i<MxN; i++)
     for (j=0; j<MxN; j++)
       ma[i][j]=r;
}


istream & operator >>(istream&s,CMatrizRacE &m)
{ CRacional r;
  int i,j;
   for (i=0; i<MxN; i++)
     for (j=0; j<MxN; j++){
       s>>m.ma[i][j];
     }
  return s;
};


ostream & operator <<(ostream&s,CMatrizRacE m)
{ CRacional r;
  int i,j;
   for (i=0; i<MxN; i++){
     for (j=0; j<MxN; j++){
       s<<m.ma[i][j]<<' ';
     }
     s<<'\n';
   }
  return s;
};

CMatrizRacE operator +(CMatrizRacE m1, CMatrizRacE m2){
CMatrizRacE resultado;
   int i,j;
   for (i=0; i<MxN; i++)
     for (j=0; j<MxN; j++)
       resultado.ma[i][j]=m1.ma[i][j]+m2.ma[i][j];
   return resultado;
}

CMatrizRacE operator -(CMatrizRacE m1, CMatrizRacE m2){
CMatrizRacE resultado;
   int i,j;
   for (i=0; i<MxN; i++)
     for (j=0; j<MxN; j++)
       resultado.ma[i][j]=m1.ma[i][j]-m2.ma[i][j];
   return resultado;
}


CMatrizRacE CMatrizRacE::operator =(const CMatrizRacE & m){
   int i,j;
   for (i=0; i<MxN; i++)
     for (j=0; j<MxN; j++)
       ma[i][j]=m.ma[i][j];
   return *this;
}

