
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

class Punto
{
  int x;
  int y;
  public:
  void fijarxy(int a, int b)
	{x=a;y=b;}
  int Accesarx()
	{
	 return x;
	}
  int Accesary()
	{
	 return y;
	}
};

class Figura
{
 int color;
 Punto centro;
 public:
	Figura() {Fijar_color(15);}
	int Traer_color() {return color;}
	void Fijar_color(int col) {color=col;}
	Punto Traer_centro() {return centro;}
	void Fijar_centro(Punto p) {centro=p;}

};

class Circulo: public Figura
{
 int radio;
 public:
	Circulo(int r,Punto c) {radio=r;Fijar_centro(c);};
	int Traer_radio() {return radio;};
	void Fijar_radio(int r) {radio=r;};
	void Dibuja();
};

void Circulo::Dibuja(){
  setcolor(Traer_color());
  Punto p;
  p=Traer_centro();
  circle(p.Accesarx(),p.Accesary(),Traer_radio());
}

class Rectangulo: public Figura
{
 int base, altura;
 public:
	Rectangulo  (int b, int a,Punto c) {base=b; altura=a;Fijar_centro(c);}
	int Traer_base() {return base;}
	int Traer_altura() {return altura;}
	void Fijar_base_altura (int b, int a) {base=b; altura=a;}
	void Dibuja();

};

void Rectangulo::Dibuja(){
  setcolor(Traer_color());
  Punto p;
  p=Traer_centro();
  int b=Traer_base()/2;
  int a=Traer_altura()/2;
  rectangle(p.Accesarx()-b,p.Accesary()-a,p.Accesarx()+b,p.Accesary()+a);
}

int main(void)
{
	int gdriver = DETECT, gmode, errorcode;
	initgraph(&gdriver, &gmode, "");
	errorcode = graphresult();
	if (errorcode != grOk)  /* an error occurred */
	{
	  printf("Graphics error: %s\n", grapherrormsg(errorcode));
	  printf("Press any key to halt:");
	  getch();
	  exit(1);             /* return with error code */
	}

	char f;
	int x,y;
	Punto p;
	p.fijarxy(320,240);
	Circulo cir(100,p);
	Circulo cir2(100,p);
	cir.Fijar_color(9);
	cir2.Fijar_color(0);
	cir.Dibuja();
  /* p.fijarxy(320,240);
	Rectangulo r(80,40,p);
	r.Fijar_color(15);
	r.Dibuja();
	 */
	while ( f!=27){
	  f=getch();
	  cir2.Fijar_centro(cir.Traer_centro());
	  //cir2.radio=cir.Traer_radio;
	  cir2.Dibuja();
	  x=p.Accesarx();
	  y=p.Accesary();
	  switch(f){
		 case 72:y-=10;break;
		 case 80:y+=10;break;
		 case 75:x-=10;break;
		 case 77:x+=10;break;
	  }
	  p.fijarxy(x,y);
	  cir.Fijar_centro(p);
	  cir.Dibuja();
	}
	closegraph();
   return 0;
}
